Scriptname mslDC2ConfigSCR extends SKI_ConfigBase  

; SCRIPT VERSION
int function GetVersion()
	return 1
endFunction

event OnConfigInit()
	Pages = new string[2]
	Pages[0] = "$mslDCOptions"	;Options
	Pages[1] = "$mslDCDeviousDevices"	;Devious Devices
endEvent

event OnVersionUpdate(int a_version)
	if (a_version > 1)
		OnConfigInit()
	endIf
endEvent

;OIDs
int UpdateOID_T
int UninstallOID_T

int GagOID_S
int PlugsOID_S
int BeltOID_S
int BraOID_S
int CollarOID_S
int CuffsOID_S
int BlindfoldOID_S
int HarnessOID_S
int VPiercingOID_S
int NPiercingOID_S
int ArmbinderOID_S
int YokeOID_S
int BootsOID_S
int GlovesOID_S
int CorsetOID_S

int PlugsAddOID_B
int PlugsIgnoreOID_B
int PiercingsIgnoreOID_B

int TagBeltOpenOID_B

int TagGagBallOID_B
int TagGagRingOID_B
int TagGagPanelOID_B
int TagGagBitOID_B
int TagBootsPonyOID_B
int TagBootsRingOID_B
int TagBootsBalletOID_B
int TagPlugSimpleOID_B
int TagPlugMagicOID_B
int TagPlugInflatableOID_B

int TagMatPaddedOID_B
int TagMatIronOID_B
int TagMatLeatherOID_B
int TagMatEboniteOID_B
int TagMatFalmerOID_B
int TagMatWoodOID_B
int TagMatGoldOID_B
int TagMatSilverOID_B
int TagMatBronzeOID_B
int TagMatInoxOID_B
int TagMatRopeOID_B
int TagMatStripeOID_B
int TagMatHexOID_B
int TagMatHypnoticOID_B

int TagColBlackOID_B
int TagColRedOID_B
int TagColWhiteOID_B
int TagColRestrictiveOID_B
int TagColChromoOID_B
int TagColLightOID_B

int StealKeysOID_B
int SpawnKeysOID_S

int EventRobberyOID_B
int EventAssaultOID_B

;Slider values
float Property ChanceGag Auto
float Property ChancePlugs Auto
float Property ChanceBelt Auto
float Property ChanceBra Auto
float Property ChanceCollar Auto
float Property ChanceCuffs Auto
float Property ChanceBlindfold Auto
float Property ChanceHarness Auto
float Property ChanceVPiercing Auto
float Property ChanceNPiercing Auto
float Property ChanceArmbinder Auto
float Property ChanceYoke Auto
float Property ChanceBoots Auto
float Property ChanceGloves Auto
float Property ChanceCorset Auto

bool Property PlugsAddBelt Auto
bool Property PlugsIgnoreBelt Auto
bool Property PiercingsIgnoreChastity Auto

bool Property TagBeltOpen Auto

bool Property TagGagBall Auto
bool Property TagGagRing Auto
bool Property TagGagPanel Auto
bool Property TagGagBit Auto

bool Property TagBootsBallet Auto
bool Property TagBootsRing Auto
bool Property TagBootsPony Auto

bool Property TagPlugMagic Auto
bool Property TagPlugSimple Auto
bool Property TagPlugInflatable Auto

bool Property TagMatPadded Auto
bool Property TagMatIron Auto
bool Property TagMatLeather Auto
bool Property TagMatEbonite Auto
bool Property TagMatFalmer Auto
bool Property TagMatWood Auto
bool Property TagMatGold Auto
bool Property TagMatSilver Auto
bool Property TagMatBronze Auto
bool Property TagMatInox Auto
bool Property TagMatRope Auto
bool Property TagMatStripe Auto
bool Property TagMatHex Auto
bool Property TagMatHypnotic Auto

bool Property TagColBlack Auto
bool Property TagColRed Auto
bool Property TagColWhite Auto
bool Property TagColRestrictive Auto
bool Property TagColChromo Auto
bool Property TagColLight Auto

bool Property StealKeys Auto
float Property SpawnKeys Auto

bool Property EventRobbery Auto
bool Property EventAssault Auto

event OnPageReset(string page)
	if (page == "")
		LoadCustomContent("mslDeviousCaptures/title.dds", 186, 33)
		return
	else
		UnloadCustomContent()
	endIf

	if (page == "$mslDCOptions")						;Options
		;General settings and debug options
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)

		AddHeaderOption("$mslDCDebug")			;Debug
		UpdateOID_T = AddTextOption("$mslDCUpdate", "")	;Update
		UninstallOID_T = AddTextOption("$mslDCUninstall", "")	;Uninstall

		SetCursorPosition(1)

		AddHeaderOption("$mslDCEvents")			;Events
		EventRobberyOID_B = AddToggleOption("$mslDCEventRobbery", EventRobbery)	;Enable Robbery Event
		EventAssaultOID_B = AddToggleOption("$mslDCEventAssault", EventAssault)	;Enable Assault Event

		AddEmptyOption()

		AddHeaderOption("$mslDCKeys")			;Keys
		StealKeysOID_B = AddToggleOption("$mslDCStealKeys", StealKeys)	;Always steal keys
		SpawnKeysOID_S = AddSliderOption("$mslDCSpawnKeys", SpawnKeys, "{0}%")	;Spawn keys on robbers

	elseIf (page == "$mslDCDeviousDevices")			;Devious Devices
		;Devices options
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)

		AddHeaderOption("$mslDCchastitydevices")			;Chastity Devices
		BeltOID_S = AddSliderOption("$mslDCBeltHarness", ChanceBelt, "{0}%")	;Belt/Harness chance
		TagBeltOpenOID_B = AddToggleOption("$mslDCTagBeltOpen", TagBeltOpen)	;...only open Belts
		HarnessOID_S = AddSliderOption("$mslDCHarnessVsBelt", ChanceHarness, "{0}%")	;Harness vs Belt proportion

		AddEmptyOption()

		BraOID_S = AddSliderOption("$mslDCBra", ChanceBra, "{0}%")	;Bra chance

		AddEmptyOption()

		AddHeaderOption("$mslDCnaughtitydevices")			;Naughtity Devices
		PlugsOID_S = AddSliderOption("$mslDCPlugs", ChancePlugs, "{0}%")	;Plugs chance
		PlugsAddOID_B = AddToggleOption("$mslDCAddBelt", PlugsAddBelt)	;...also equips Belt
		PlugsIgnoreOID_B = AddToggleOption("$mslDCIgnoreBelt", PlugsIgnoreBelt)	;...can bypass Belts

		AddEmptyOption()

		VPiercingOID_S = AddSliderOption("$mslDCVPiercing", ChanceVPiercing, "{0}%")	;Vaginal piercings chance
		NPiercingOID_S = AddSliderOption("$mslDCNPiercing", ChanceNPiercing, "{0}%")	;Nipple piercings chance
		PiercingsIgnoreOID_B = AddToggleOption("$mslDCIgnoreChastity", PiercingsIgnoreChastity)	;...can bypass Bras and Belts

		AddEmptyOption()

		AddHeaderOption("$mslDCrestrictivedevices")			;Restrictive Devices
		GagOID_S = AddSliderOption("$mslDCGag", ChanceGag, "{0}%")	;Gag chance
		BlindfoldOID_S = AddSliderOption("$mslDCBlindfold", ChanceBlindfold, "{0}%")	;Blindfold chance
		ArmbinderOID_S = AddSliderOption("$mslDCArmbinderYoke", ChanceArmbinder, "{0}%")	;Armbinder/Yoke chance
		YokeOID_S = AddSliderOption("$mslDCYokeVsArmbinder", ChanceYoke, "{0}%")	;Yoke vs Armbinder chance

		AddEmptyOption()

		AddHeaderOption("$mslDCbasicrestraints")			;Basic Restraints
		CollarOID_S = AddSliderOption("$mslDCCollar", ChanceCollar, "{0}%")	;Collar chance
		CuffsOID_S = AddSliderOption("$mslDCCuffs", ChanceCuffs, "{0}%")	;Cuffs chance

		AddEmptyOption()

		AddHeaderOption("$mslDCother")			;Other
		BootsOID_S = AddSliderOption("$mslDCBoots", ChanceBoots, "{0}%")	;Boots chance
		GlovesOID_S = AddSliderOption("$mslDCGloves", ChanceGloves, "{0}%")	;Gloves chance
		CorsetOID_S = AddSliderOption("$mslDCCorset", ChanceCorset, "{0}%")	;Corset chance

		SetCursorPosition(1)

		AddHeaderOption("$mslDCTagMatsHeader")			;Material Selection
		TagMatPaddedOID_B = AddToggleOption("$mslDCTagMatPadded", TagMatPadded)	;Padded
		TagMatIronOID_B = AddToggleOption("$mslDCTagMatIron", TagMatIron)	;Iron
		TagMatLeatherOID_B = AddToggleOption("$mslDCTagMatLeather", TagMatLeather)	;Leather
		TagMatEboniteOID_B = AddToggleOption("$mslDCTagMatEbonite", TagMatEbonite)	;Ebonite
		TagMatSilverOID_B = AddToggleOption("$mslDCTagMatSilver", TagMatSilver)	;Silver
		TagMatBronzeOID_B = AddToggleOption("$mslDCTagMatBronze", TagMatBronze)	;Bronze
		TagMatFalmerOID_B = AddToggleOption("$mslDCTagMatFalmer", TagMatFalmer)	;Falmer
		TagMatWoodOID_B = AddToggleOption("$mslDCTagMatWood", TagMatWood)	;Wood
		TagMatGoldOID_B = AddToggleOption("$mslDCTagMatGold", TagMatGold)	;Gold
		TagMatInoxOID_B = AddToggleOption("$mslDCTagMatInox", TagMatInox)	;Inox
		TagMatRopeOID_B = AddToggleOption("$mslDCTagMatRope", TagMatRope)	;Rope
		TagMatStripeOID_B = AddToggleOption("$mslDCTagMatStripe", TagMatStripe)	;Stripe
		TagMatHexOID_B = AddToggleOption("$mslDCTagMatHex", TagMatHex)	;Hex
		TagMatHypnoticOID_B = AddToggleOption("$mslDCTagMatHypnotic", TagMatHypnotic)	;Hypnotic

		AddEmptyOption()

		AddHeaderOption("$mslDCTagVariantHeader")			;Variant Selection
		TagColBlackOID_B = AddToggleOption("$mslDCTagColBlack", TagColBlack)	;Black
		TagColRedOID_B = AddToggleOption("$mslDCTagColRed", TagColRed)	;Red
		TagColWhiteOID_B = AddToggleOption("$mslDCTagColWhite", TagColWhite)	;White
		TagColRestrictiveOID_B = AddToggleOption("$mslDCTagColRestrictive", TagColRestrictive)	;Restrictive
		TagColChromoOID_B = AddToggleOption("$mslDCTagColChromo", TagColChromo)	;Chromo
		TagColLightOID_B = AddToggleOption("$mslDCTagColLight", TagColLight)	;Light wood

		AddEmptyOption()

		AddHeaderOption("$mslDCTagTypeHeader")			;Type Selection
		TagGagBallOID_B = AddToggleOption("$mslDCTagGagBall", TagGagBall)	;(Gag) Ball
		TagGagRingOID_B = AddToggleOption("$mslDCTagGagRing", TagGagRing)	;(Gag) Ring
		TagGagPanelOID_B = AddToggleOption("$mslDCTagGagPanel", TagGagPanel)	;(Gag) Panel
		TagGagBitOID_B = AddToggleOption("$mslDCTagGagBit", TagGagBit)	;(Gag) Bit

		TagBootsPonyOID_B = AddToggleOption("$mslDCTagBootsPony", TagBootsPony)	;(Boots) Pony
		TagBootsBalletOID_B = AddToggleOption("$mslDCTagBootsBallet", TagBootsBallet)	;(Boots) Ballet
		TagBootsRingOID_B = AddToggleOption("$mslDCTagBootsRing", TagBootsRing)	;(Boots) Ring

		TagPlugSimpleOID_B = AddToggleOption("$mslDCTagPlugSimple", TagPlugSimple)	;(Plugs) Simple
		TagPlugMagicOID_B = AddToggleOption("$mslDCTagPlugMagic", TagPlugMagic)	;(Plugs) Magic
		TagPlugInflatableOID_B = AddToggleOption("$mslDCTagPlugInflatable", TagPlugInflatable)	;(Plugs) Inflatable

	endIf
endEvent

event OnOptionSelect(int option)

	if (option == UpdateOID_T)
 		ShowMessage("$mslDCdebexitmenu", false)	;Selected option will take effect once you exit menu.
		mslDC2MainQST.Stop()
		mslDC2MainQST.Start()
	elseif (option == UninstallOID_T)
 		ShowMessage("$mslDCdebexitmenu", false)	;Selected option will take effect once you exit menu.
		mslDC2MainQST.Stop()

	elseif (option == PlugsAddOID_B)
		PlugsAddBelt = !PlugsAddBelt
		SetToggleOptionValue(PlugsAddOID_B, PlugsAddBelt)
	elseif (option == PlugsIgnoreOID_B)
		PlugsIgnoreBelt = !PlugsIgnoreBelt
		SetToggleOptionValue(PlugsIgnoreOID_B, PlugsIgnoreBelt)
	elseif (option == TagBeltOpenOID_B)
		TagBeltOpen = !TagBeltOpen
		SetToggleOptionValue(TagBeltOpenOID_B, TagBeltOpen)
	elseif (option == PiercingsIgnoreOID_B)
		PiercingsIgnoreChastity = !PiercingsIgnoreChastity
		SetToggleOptionValue(PiercingsIgnoreOID_B, PiercingsIgnoreChastity)

	elseif (option == EventRobberyOID_B)
		EventRobbery = !EventRobbery
		SetToggleOptionValue(EventRobberyOID_B, EventRobbery)
	elseif (option == EventAssaultOID_B)
		EventAssault = !EventAssault
		SetToggleOptionValue(EventAssaultOID_B, EventAssault)

	elseif (option == StealKeysOID_B)
		StealKeys = !StealKeys
		SetToggleOptionValue(StealKeysOID_B, StealKeys)

	elseif (option == TagMatPaddedOID_B)
		TagMatPadded = !TagMatPadded
		SetToggleOptionValue(TagMatPaddedOID_B, TagMatPadded)
	elseif (option == TagMatIronOID_B)
		TagMatIron = !TagMatIron
		SetToggleOptionValue(TagMatIronOID_B, TagMatIron)
	elseif (option == TagMatLeatherOID_B)
		TagMatLeather = !TagMatLeather
		SetToggleOptionValue(TagMatLeatherOID_B, TagMatLeather)
	elseif (option == TagMatEboniteOID_B)
		TagMatEbonite = !TagMatEbonite
		SetToggleOptionValue(TagMatEboniteOID_B, TagMatEbonite)
	elseif (option == TagMatFalmerOID_B)
		TagMatFalmer = !TagMatFalmer
		SetToggleOptionValue(TagMatFalmerOID_B, TagMatFalmer)
	elseif (option == TagMatWoodOID_B)
		TagMatWood = !TagMatWood
		SetToggleOptionValue(TagMatWoodOID_B, TagMatWood)
	elseif (option == TagMatGoldOID_B)
		TagMatGold = !TagMatGold
		SetToggleOptionValue(TagMatGoldOID_B, TagMatGold)
	elseif (option == TagMatSilverOID_B)
		TagMatSilver = !TagMatSilver
		SetToggleOptionValue(TagMatSilverOID_B, TagMatSilver)
	elseif (option == TagMatBronzeOID_B)
		TagMatBronze = !TagMatBronze
		SetToggleOptionValue(TagMatBronzeOID_B, TagMatBronze)
	elseif (option == TagMatInoxOID_B)
		TagMatInox = !TagMatInox
		SetToggleOptionValue(TagMatInoxOID_B, TagMatInox)
	elseif (option == TagMatRopeOID_B)
		TagMatRope = !TagMatRope
		SetToggleOptionValue(TagMatRopeOID_B, TagMatRope)
	elseif (option == TagMatStripeOID_B)
		TagMatStripe = !TagMatStripe
		SetToggleOptionValue(TagMatStripeOID_B, TagMatStripe)
	elseif (option == TagMatHexOID_B)
		TagMatHex = !TagMatHex
		SetToggleOptionValue(TagMatHexOID_B, TagMatHex)
	elseif (option == TagMatHypnoticOID_B)
		TagMatHypnotic = !TagMatHypnotic
		SetToggleOptionValue(TagMatHypnoticOID_B, TagMatHypnotic)

	elseif (option == TagColBlackOID_B)
		TagColBlack = !TagColBlack
		SetToggleOptionValue(TagColBlackOID_B, TagColBlack)
	elseif (option == TagColRedOID_B)
		TagColRed = !TagColRed
		SetToggleOptionValue(TagColRedOID_B, TagColRed)
	elseif (option == TagColWhiteOID_B)
		TagColWhite = !TagColWhite
		SetToggleOptionValue(TagColWhiteOID_B, TagColWhite)
	elseif (option == TagColRestrictiveOID_B)
		TagColRestrictive = !TagColRestrictive
		SetToggleOptionValue(TagColRestrictiveOID_B, TagColRestrictive)
	elseif (option == TagColChromoOID_B)
		TagColChromo = !TagColChromo
		SetToggleOptionValue(TagColChromoOID_B, TagColChromo)
	elseif (option == TagColLightOID_B)
		TagColLight = !TagColLight
		SetToggleOptionValue(TagColLightOID_B, TagColLight)

	elseif (option == TagGagBallOID_B)
		TagGagBall = !TagGagBall
		SetToggleOptionValue(TagGagBallOID_B, TagGagBall)
	elseif (option == TagGagRingOID_B)
		TagGagRing = !TagGagRing
		SetToggleOptionValue(TagGagRingOID_B, TagGagRing)
	elseif (option == TagGagPanelOID_B)
		TagGagPanel = !TagGagPanel
		SetToggleOptionValue(TagGagPanelOID_B, TagGagPanel)
	elseif (option == TagGagBitOID_B)
		TagGagBit = !TagGagBit
		SetToggleOptionValue(TagGagBitOID_B, TagGagBit)
	elseif (option == TagBootsPonyOID_B)
		TagBootsPony = !TagBootsPony
		SetToggleOptionValue(TagBootsPonyOID_B, TagBootsPony)
	elseif (option == TagBootsRingOID_B)
		TagBootsRing = !TagBootsRing
		SetToggleOptionValue(TagBootsRingOID_B, TagBootsRing)
	elseif (option == TagBootsBalletOID_B)
		TagBootsBallet = !TagBootsBallet
		SetToggleOptionValue(TagBootsBalletOID_B, TagBootsBallet)
	elseif (option == TagPlugSimpleOID_B)
		TagPlugSimple = !TagPlugSimple
		SetToggleOptionValue(TagPlugSimpleOID_B, TagPlugSimple)
	elseif (option == TagPlugMagicOID_B)
		TagPlugMagic = !TagPlugMagic
		SetToggleOptionValue(TagPlugMagicOID_B, TagPlugMagic)
	elseif (option == TagPlugInflatableOID_B)
		TagPlugInflatable = !TagPlugInflatable
		SetToggleOptionValue(TagPlugInflatableOID_B, TagPlugInflatable)
	endif
endEvent

event OnOptionSliderOpen(int option)
	if (option == GagOID_S)
		SetSliderDialogStartValue(ChanceGag)
		SetSliderDialogDefaultValue(15.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == PlugsOID_S)
		SetSliderDialogStartValue(ChancePlugs)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == BeltOID_S)
		SetSliderDialogStartValue(ChanceBelt)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == BraOID_S)
		SetSliderDialogStartValue(ChanceBra)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == CollarOID_S)
		SetSliderDialogStartValue(ChanceCollar)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == CuffsOID_S)
		SetSliderDialogStartValue(ChanceCuffs)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == BlindfoldOID_S)
		SetSliderDialogStartValue(ChanceBlindfold)
		SetSliderDialogDefaultValue(15.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == HarnessOID_S)
		SetSliderDialogStartValue(ChanceHarness)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == NPiercingOID_S)
		SetSliderDialogStartValue(ChanceNPiercing)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == VPiercingOID_S)
		SetSliderDialogStartValue(ChanceVPiercing)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == ArmbinderOID_S)
		SetSliderDialogStartValue(ChanceArmbinder)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == YokeOID_S)
		SetSliderDialogStartValue(ChanceYoke)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == BootsOID_S)
		SetSliderDialogStartValue(ChanceBoots)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == GlovesOID_S)
		SetSliderDialogStartValue(ChanceGloves)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif (option == CorsetOID_S)
		SetSliderDialogStartValue(ChanceCorset)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)

	elseif (option == SpawnKeysOID_S)
		SetSliderDialogStartValue(SpawnKeys)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	endIf
endEvent

event OnOptionSliderAccept(int option, float value)
	if (option == GagOID_S)
		ChanceGag = value
		SetSliderOptionValue(GagOID_S, ChanceGag, "{0}%")
	elseif (option == PlugsOID_S)
		ChancePlugs = value
		SetSliderOptionValue(PlugsOID_S, ChancePlugs, "{0}%")
	elseif (option == BeltOID_S)
		ChanceBelt = value
		SetSliderOptionValue(BeltOID_S, ChanceBelt, "{0}%")
	elseif (option == BraOID_S)
		ChanceBra = value
		SetSliderOptionValue(BraOID_S, ChanceBra, "{0}%")
	elseif (option == CollarOID_S)
		ChanceCollar = value
		SetSliderOptionValue(CollarOID_S, ChanceCollar, "{0}%")
	elseif (option == CuffsOID_S)
		ChanceCuffs = value
		SetSliderOptionValue(CuffsOID_S, ChanceCuffs, "{0}%")
	elseif (option == BlindfoldOID_S)
		ChanceBlindfold = value
		SetSliderOptionValue(BlindfoldOID_S, ChanceBlindfold, "{0}%")
	elseif (option == HarnessOID_S)
		ChanceHarness = value
		SetSliderOptionValue(HarnessOID_S, ChanceHarness, "{0}%")
	elseif (option == NPiercingOID_S)
		ChanceNPiercing = value
		SetSliderOptionValue(NPiercingOID_S, ChanceNPiercing, "{0}%")
	elseif (option == VPiercingOID_S)
		ChanceVPiercing = value
		SetSliderOptionValue(VPiercingOID_S, ChanceVPiercing, "{0}%")
	elseif (option == ArmbinderOID_S)
		ChanceArmbinder = value
		SetSliderOptionValue(ArmbinderOID_S, ChanceArmbinder, "{0}%")
	elseif (option == YokeOID_S)
		ChanceYoke = value
		SetSliderOptionValue(YokeOID_S, ChanceYoke, "{0}%")
	elseif (option == BootsOID_S)
		ChanceBoots = value
		SetSliderOptionValue(BootsOID_S, ChanceBoots, "{0}%")
	elseif (option == GlovesOID_S)
		ChanceGloves = value
		SetSliderOptionValue(GlovesOID_S, ChanceGloves, "{0}%")
	elseif (option == CorsetOID_S)
		ChanceCorset = value
		SetSliderOptionValue(CorsetOID_S, ChanceCorset, "{0}%")

	elseif (option == SpawnKeysOID_S)
		SpawnKeys  = value
		SetSliderOptionValue(SpawnKeysOID_S, SpawnKeys, "{0}%")
	endIf
endEvent

event OnOptionHighlight(int option)
	if (option == UpdateOID_T)
		SetInfoText("$mslDCUpdateHL")	;This will reset the controller quest allowing Captures to update to a newer version or fix unexpected bugs.\nUse as a panic button! If something is wrong: press it
	elseIf (option == UninstallOID_T)
		SetInfoText("$mslDCUninstallHL")	;This will disable the controller quest and stop all its scripts.\nIf you're uninstalling Devious Captures please always use this BEFORE you untick the mod in your plugic manager!\nIf you only want to disable Captures temporarily you can use Update afterwards to bring it back online
	elseIf (option == EventRobberyOID_B)
		SetInfoText("$mslDCEventRobberyHL")	;Robbery Event happens during Defeat's robbery scene. The robber has a chance to equip a number of Devious Devices on your character.
	elseIf (option == EventAssaultOID_B)
		SetInfoText("$mslDCEventAssaultHL")	;Assault Event happens at the end of Defeat's rape. Each time your character is raped the attacker has a chance to equip a single Devious Device on her or him.
	elseIf (option == StealKeysOID_B)
		SetInfoText("$mslDCStealKeysHL")	;Enable this to let robbers and rapists always steal your character's device keys regardless of Defeat's robbery settings.
	elseIf (option == SpawnKeysOID_S)
		SetInfoText("$mslDCSpawnKeysHL")	;Set the probability that the person who equipped devices on your character will have matching keys.\nWarning! If you decide to use this setting it's recommended that you also enable "Destroy Keys" in Integration's MCM.

	elseIf (option == BeltOID_S)
		SetInfoText("$mslDCBeltHarnessHL")	;Set the chance to receive a Chastity Belt or Harness.\nBoth of these devices prevent vaginal and anal sex which will interfere with achieving orgasm.
	elseIf (option == TagBeltOpenOID_B)
		SetInfoText("$mslDCTagBeltOpenHL")	;Enable this to only receive open variants of Chastity Belts. Harnesses are unaffected.\nOpen Belts permit anal sex.
	elseIf (option == HarnessOID_S)
		SetInfoText("$mslDCHarnessVsBeltHL")	;Set the relative chance to receive a Harness instead of a Belt.\nWarning! If your character is already wearing a Collar a Belt will be chosen regardless of this setting.
	elseIf (option == BraOID_S)
		SetInfoText("$mslDCBraHL")	;Set the chance to receive a Chastity Bra.\nChastity Bras interfere with melee combat skills and archery as well as prevent breast sex.
	elseIf (option == PlugsOID_S)
		SetInfoText("$mslDCPlugsHL")	;Set the chance to receive a pair of random Plugs.\nPlugs are held in place by a Belt or Harness and will subject the wearer to various effects based on type.
	elseIf (option == PlugsAddOID_B)
		SetInfoText("$mslDCPlugsAddBeltHL")	;Enable this to automatically add a Belt or Harness when plugs are equipped.\nThis will happen even if Belt/Harness chance is set to 0%.\nHarness vs Belt chance and other related settings are still taken into account
	elseIf (option == PlugsIgnoreOID_B)
		SetInfoText("$mslDCPlugsIgnoreBeltHL")	;Enable this to allow equipping plugs even if your character is already wearing a Belt or Harness.
	elseIf (option == NPiercingOID_S)
		SetInfoText("$mslDCNPiercingHL")	;Set the chance to receive Nipple Piercings.\nThese piercings can be worn on their own or underneath a Bra and will periodically vibrate or subject the wearer to other effects based on type.
	elseIf (option == VPiercingOID_S)
		SetInfoText("$mslDCVPiercingHL")	;Set the chance to receive Vaginal Piercings.\nThese piercings can be worn on their own or underneath a Belt and will periodically vibrate or subject the wearer to other effects based on type.
	elseIf (option == PiercingsIgnoreOID_B)
		SetInfoText("$mslDCPiercingsIgnoreChastityHL")	;Enable this to allow equipping Piercings even if your character is already wearing a Bra or Belt/Harness.
	elseIf (option == GagOID_S)
		SetInfoText("$mslDCGagHL")	;Set the chance to receive a random Gag.\nWarning! Gags hinder your ability to communicate with NPCs and consume food.\nIncrease their spawn rate at your own peril!
	elseIf (option == BlindfoldOID_S)
		SetInfoText("$mslDCBlindfoldHL")	;Set the chance to receive a random Blindfold.\nWarning! Blindfold is a very restrictive device that will affect your gameplay! Please make sure you know what they do before you increase this value.\nYou can adjust how Blindfolds work in Integration's MCM menu. 
	elseIf (option == ArmbinderOID_S)
		SetInfoText("$mslDCArmbinderYokeHL")	;Set the chance to receive an Armbinder or Yoke.\nWarning! Armbinders and Yokes are the most restrictive of Devious Devices. They will prevent you from fighting, sprinting and casting spells. They may also break animated scenes if equipped at the wrong time.\nIncrease their spawn rate at your own peril!
	elseIf (option == YokeOID_S)
		SetInfoText("$mslDCYokeHL")	;Set the relative chance to receive a Yoke instead of an Armbinder.\nWarning! Yokes are even more difficult to get out of than Armbinders! You will require a Restraints Key in addition to a lot of struggling to even have a chance!
	elseIf (option == CollarOID_S)
		SetInfoText("$mslDCCollarHL")	;Set the chance to receive a random Collar.\nCollars will cause the wearer some discomfort but will not typically affect gameplay.
	elseIf (option == CuffsOID_S)
		SetInfoText("$mslDCCuffsHL")	;Set the chance to receive a random set of Cuffs.\nCuffs will cause the wearer some discomfort but will not typically affect gameplay.
	elseIf (option == BootsOID_S)
		SetInfoText("$mslDCBootsHL")	;Set the chance to receive a random pair of Shoes/Boots.\nThese securely  locked high heels will significantly slow down the wearer and can periodically cause tripping.\nWarning! Devious Devices Expansion is required. If you don't have it installed Boots won't spawn.
	elseIf (option == GlovesOID_S)
		SetInfoText("$mslDCGlovesHL")	;Set the chance to receive a random pair of Gloves.\nThese locking gloves will take up the hands slot but will not typically affect gameplay.
	elseIf (option == CorsetOID_S)
		SetInfoText("$mslDCCorsetHL")	;Set the chance to receive a random Corset.\nThis tight corset will severely restrict the wearer's breathing, interfering with shouts and stamina management.\nWarning! Corset cannot be worn together with Harness.

	elseIf (option == TagMatEboniteOID_B)
		SetInfoText("$mslDCReqDDxHL")	;Requires: Devious Devices Expansion
	elseIf (option == TagMatSilverOID_B || option == TagMatBronzeOID_B)
		SetInfoText("$mslDCReqCDHL")	;Requires: Captured Dreams
	elseIf (option == TagMatFalmerOID_B || option == TagMatWoodOID_B || option == TagMatGoldOID_B || option == TagMatInoxOID_B || option == TagMatRopeOID_B || option == TagMatStripeOID_B || option == TagMatHexOID_B || option == TagMatHypnoticOID_B)
		SetInfoText("$mslDCReqDDeHL")	;Requires: Devious Devices Equip
	endIf
endEvent

Quest Property mslDC2MainQST Auto