Scriptname mslDC2FunctionsSCR extends Quest  

import utility
import debug

;LOCAL VARIABLES
bool equipGag
bool equipPlugs
bool equipHarness
bool equipBelt
bool equipBra
bool equipCollar
bool equipACuffs
bool equipLCuffs
bool equipArmbinder
bool equipYoke
bool equipBlindfold
bool equipNPiercings
bool equipVPiercings
bool equipBoots
bool equipGloves
bool equipCorset

;LOCAL STRINGS
string gagExclTags
string beltExclTags
string harnessExclTags
string blindfoldExclTags
string bootsExclTags
string plugsExclTags

string exclTags

;LOCAL PROPERTIES
Actor Property PlayerRef Auto
ObjectReference Property RobberRef Auto
Keyword Property ActorTypeNPC Auto
mslDC2ConfigSCR Property mslDC2ConfigQST Auto

;DEVIOUS DEVICES PROPERTIES
zadLibs Property libs Auto

;DEFEAT PROPERTIES
ReferenceAlias Property Robber Auto

;SEXLAB PROPERTIES
SexLabFramework Property SexLab Auto

Event OnInit()
	RegisterForDefeatEvents()
	Notification("Devious Captures initialised!")
EndEvent

Function RegisterForDefeatEvents()
	RegisterForModEvent("DefeatPostAssault", "OnCaptureTrigger")
	RegisterForModEvent("OrgasmStart_DefeatPvic", "OnAssaultEnd")
	Trace("Devious Captures: Defeat events registered")
EndFunction

Function UnRegisterForDefeatEvents()
	UnRegisterForModEvent("DefeatPostAssault")
	UnRegisterForModEvent("OrgasmStart_DefeatPvic")
EndFunction

Event OnCaptureTrigger(string eventName, string argString, float argNum, form sender)
;	if argString == "BlackOutBegin"
;		Trace("Devious Captures: triggered by blackout  event")
;		DeviousPrepare()
;	elseif argString == "LFDBegin"
;		Trace("Devious Captures: post assault wilderness event detected")
;		DeviousEquip()
;	elseif argString == "DefeatedBegin"
;		Trace("Devious Captures: post assault inn event detected")
;		DeviousEquip()
;	endif

	if mslDC2ConfigQST.EventRobbery && argString == "RobBegin"
		Trace("Devious Captures: triggered by robbery event")
		DeviousClear()
		DeviousPrepare()
		DeviousRobbery()
		DeviousEquip()
	elseif !mslDC2ConfigQST.EventRobbery && argString == "RobBegin"
		Trace("Devious Captures: robbery event detected but not triggered")
	endif
EndEvent

Event OnAssaultEnd(string eventName, string argString, float argNum, form sender)

	Actor[] actorList = SexLab.HookActors(argString)
		
	If (actorList.length < 1)
		return
	EndIf
		
	Actor akVictim = SexLab.HookVictim(argString)
	Actor akRef

	If (akVictim == PlayerRef)
		int i = 0
		While i < actorList.length
			If (akVictim != actorList[i])
				akRef = actorList[i]
			EndIf
			i += 1
		EndWhile
	Endif

	Trace("Devious Captures: akVictim = " +  akVictim.GetLeveledActorBase().GetName() + "; akRef = " + akRef.GetLeveledActorBase().GetName())

	if mslDC2ConfigQST.EventAssault && akRef.HasKeyword(ActorTypeNPC)
		Trace("Devious Captures: triggered by assault event")
		DeviousClear()
		DeviousPrepare()
		DeviousPickOne()
		DeviousRobbery()
		DeviousEquip()
	else	
		Trace("Devious Captures: assault event detected but not triggered")
	endif

EndEvent

Function DeviousClear()
;Reset the randomiser

	Trace("Devious Captures: resetting RNG")

	equipGag = false
	equipVPiercings = false
	equipPlugs = false
	equipBelt = false
	equipHarness = false
	equipBra = false
	equipNPiercings = false
	equipCollar = false
	equipACuffs = false
	equipLCuffs = false
	equipBlindfold = false
	equipArmbinder = false
	equipYoke = false
	equipBoots = false
	equipGloves = false
	equipCorset = false

EndFunction

Function DeviousPickOne()
;Only pick one device from all that passed the check

	Trace("Devious Captures: selecting a single device from the pool of prepared devices")

	if equipCollar
		DeviousClear()
		equipCollar = true
	elseif equipACuffs
		DeviousClear()
		equipACuffs = true
	elseif equipLCuffs
		DeviousClear()
		equipLCuffs = true
	elseif equipBoots && Libs.GetGenericDeviceByKeyword(Libs.zad_DeviousBoots)
		DeviousClear()
		equipBoots = true
	elseif equipGloves
		DeviousClear()
		equipGloves = true
	elseif equipBlindfold
		DeviousClear()
		equipBlindfold = true
	elseif equipGag
		DeviousClear()
		equipGag = true
	elseif equipVPiercings
		DeviousClear()
		equipVPiercings = true
	elseif equipNPiercings
		DeviousClear()
		equipNPiercings = true
	elseif equipBra
		DeviousClear()
		equipBra = true
	elseif equipCorset
		DeviousClear()
		equipCorset = true
	elseif equipPlugs
		DeviousClear()
		equipPlugs = true
		If mslDC2ConfigQST.PlugsAddBelt && !PlayerRef.WornHasKeyword(libs.zad_DeviousBelt)
			equipHarness = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceHarness && !PlayerRef.WornHasKeyword(libs.zad_DeviousCollar))
			equipBelt = !equipHarness
		Endif
	elseif equipHarness
		DeviousClear()
		equipHarness = true
	elseif equipBelt
		DeviousClear()
		equipBelt = true
	elseif equipYoke
		DeviousClear()
		equipYoke = true
	elseif equipArmbinder
		DeviousClear()
		equipArmbinder = true
	endif

EndFunction

Function DeviousPrepare()
;Deviously determine what restraints to equip

	Trace("Devious Captures: deploying RNG and restricting to eligible devices")

	equipGag = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceGag && !PlayerRef.WornHasKeyword(libs.zad_DeviousGag))
	equipVPiercings = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceVPiercing && !PlayerRef.WornHasKeyword(libs.zad_DeviousPiercingsVaginal) && (!PlayerRef.WornHasKeyword(libs.zad_DeviousBelt) || mslDC2ConfigQST.PiercingsIgnoreChastity))
	equipNPiercings = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceNPiercing && !PlayerRef.WornHasKeyword(libs.zad_DeviousPiercingsNipple) && (!PlayerRef.WornHasKeyword(libs.zad_DeviousBra) || mslDC2ConfigQST.PiercingsIgnoreChastity))
	equipPlugs = (RandomInt(1,100) <= mslDC2ConfigQST.ChancePlugs && !PlayerRef.WornHasKeyword(libs.zad_DeviousPlug) && (!PlayerRef.WornHasKeyword(libs.zad_DeviousBelt) || mslDC2ConfigQST.PlugsIgnoreBelt)) && (!PlayerRef.WornHasKeyword(libs.zad_DeviousPlugVaginal) || !PlayerRef.WornHasKeyword(libs.zad_DeviousPlugAnal))
	If ((equipPlugs && mslDC2ConfigQST.PlugsAddBelt || RandomInt(1,100) <= mslDC2ConfigQST.ChanceBelt) && !PlayerRef.WornHasKeyword(libs.zad_DeviousBelt))
		equipHarness = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceHarness && !PlayerRef.WornHasKeyword(libs.zad_DeviousCollar) && !PlayerRef.WornHasKeyword(libs.zad_DeviousCorset))
		equipBelt = !equipHarness
	Endif
	equipBra = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceBra && !PlayerRef.WornHasKeyword(libs.zad_DeviousBra))
	equipCollar = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceCollar && !PlayerRef.WornHasKeyword(libs.zad_DeviousCollar) && !PlayerRef.WornHasKeyword(libs.zad_DeviousHarness))
	equipACuffs = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceCuffs) && !PlayerRef.WornHasKeyword(libs.zad_DeviousArmCuffs)
	equipLCuffs = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceCuffs) && !PlayerRef.WornHasKeyword(libs.zad_DeviousLegCuffs)
	equipBlindfold = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceBlindfold && !PlayerRef.WornHasKeyword(libs.zad_DeviousBlindfold))
	If (RandomInt(1,100) <= mslDC2ConfigQST.ChanceArmbinder && !PlayerRef.WornHasKeyword(libs.zad_DeviousArmbinder) && !PlayerRef.WornHasKeyword(libs.zad_DeviousYoke))
		equipYoke = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceYoke)
		equipArmbinder = !equipYoke
	Endif
	equipBoots = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceBoots && !PlayerRef.WornHasKeyword(libs.zad_DeviousBoots))
	equipGloves = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceGloves && !PlayerRef.WornHasKeyword(libs.zad_DeviousGloves))
	equipCorset = (RandomInt(1,100) <= mslDC2ConfigQST.ChanceCorset && !PlayerRef.WornHasKeyword(libs.zad_DeviousCorset) && !PlayerRef.WornHasKeyword(libs.zad_DeviousHarness))

	Trace("Devious Captures: device equip chances calculated")

EndFunction

Function DeviousRobbery()
;Deviously manage interactions with the Robber alias

	RobberRef = Robber.GetReference()
	Trace("Devious Captures: Robber is: " + RobberRef)

	;Spawn keys on robber depending on devices she or he can equip on player
	If mslDC2ConfigQST.SpawnKeys > 0
		if (equipGag || equipCollar || equipACuffs || equipLCuffs || equipBlindfold || equipBoots || equipGloves || equipCorset || equipYoke) && RandomInt(1,100) <= mslDC2ConfigQST.SpawnKeys
			RobberRef.AddItem(Libs.restraintsKey)
		endif
		if (equipBelt || equipHarness || equipBra) && RandomInt(1,100) <= mslDC2ConfigQST.SpawnKeys
			RobberRef.AddItem(Libs.chastityKey)
		endif
		if (equipVPiercings || equipNPiercings) && RandomInt(1,100) <= mslDC2ConfigQST.SpawnKeys
			RobberRef.AddItem(Libs.piercingKey)
		endif
	Endif

	;Steal keys from player regardless of Defeat's robbery settings
	If mslDC2ConfigQST.StealKeys
		PlayerRef.RemoveItem(Libs.restraintsKey, PlayerRef.GetItemCount(Libs.restraintsKey), TRUE, RobberRef)
		PlayerRef.RemoveItem(Libs.chastityKey, PlayerRef.GetItemCount(Libs.chastityKey), TRUE, RobberRef)
		PlayerRef.RemoveItem(Libs.piercingKey, PlayerRef.GetItemCount(Libs.piercingKey), TRUE, RobberRef)
	Endif

EndFunction

Function DefineTags()

	gagExclTags = ""
	if !mslDC2ConfigQST.TagGagBall
		gagExclTags += ",ball"
	endif
	if !mslDC2ConfigQST.TagGagRing
		gagExclTags += ",ring"
	endif
	if !mslDC2ConfigQST.TagGagPanel
		gagExclTags += ",panel"
	endif
	if !mslDC2ConfigQST.TagGagBit
		gagExclTags += ",bit"
	endif

	bootsExclTags = ""
	if !mslDC2ConfigQST.TagBootsPony
		bootsExclTags += ",pony"
	endif
	if !mslDC2ConfigQST.TagBootsPony
		bootsExclTags += ",ballet"
	endif
	if !mslDC2ConfigQST.TagBootsPony
		bootsExclTags += ",ring"
	endif

	plugsExclTags = ""
	if !mslDC2ConfigQST.TagPlugSimple
		plugsExclTags += ",simple"
	endif
	if !mslDC2ConfigQST.TagPlugMagic
		plugsExclTags += ",magic"
	endif
	if !mslDC2ConfigQST.TagPlugInflatable
		plugsExclTags += ",inflatable"
	endif

	beltExclTags = ""
	if mslDC2ConfigQST.TagBeltOpen
		beltExclTags += ",full"
	endif

	harnessExclTags = ",locked,blocking"
	blindfoldExclTags = ",blocking"

	exclTags = "DCexcluded"

	if !mslDC2ConfigQST.TagColLight
		exclTags += ",light"
	endif
	if !mslDC2ConfigQST.TagColChromo
		exclTags += ",chromo"
	endif
	if !mslDC2ConfigQST.TagColRestrictive
		exclTags += ",restrictive"
	endif
	if !mslDC2ConfigQST.TagColBlack
		exclTags += ",black"
	endif
	if !mslDC2ConfigQST.TagColWhite
		exclTags += ",white"
	endif
	if !mslDC2ConfigQST.TagColRed
		exclTags += ",red"
	endif

	Trace("Devious Captures Excluded Tags: Gag = " + gagExclTags + "; Belt = " + beltExclTags + "; Harness = " + harnessExclTags + "; Variants = " + exclTags + "; ")

EndFunction

Function DeviousEquip()
;Deviously equip the devices

	DefineTags()

;ManipulateGenericDevice(actor akActor, armor device, bool equipOrUnequip, bool skipEvents = false , bool skipMutex = false)

	If equipGag
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousGag, tags = "gag", requireAll = false, tagsToSuppress = exclTags+gagExclTags), TRUE, FALSE, TRUE)
	Endif

	If equipVPiercings
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousPiercingsVaginal, tags = "piercing,vaginal", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	If equipPlugs
		if !PlayerRef.WornHasKeyword(libs.zad_DeviousPlugVaginal)
			Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousPlugVaginal, tags = "plug,vaginal", requireAll = false, tagsToSuppress = exclTags+plugsExclTags), TRUE, TRUE, TRUE)
		endif
		if !PlayerRef.WornHasKeyword(libs.zad_DeviousPlugAnal)
			Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousPlugAnal, tags = "plug,anal", requireAll = false, tagsToSuppress = exclTags+plugsExclTags), TRUE, TRUE, TRUE)
		endif
	Endif

	If equipCorset
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousCorset, tags = "corset", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
		If equipHarness == TRUE
			equipHarness = FALSE
			equipBelt = TRUE
		Endif
	Endif

	If equipHarness
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousHarness, tags = "harness", tagsToSuppress = exclTags+harnessExclTags), TRUE, FALSE, TRUE)
		equipCollar = FALSE
	Endif

	If equipBelt
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousBelt, tags = "belt", requireAll = false, tagsToSuppress = exclTags+beltExclTags), TRUE, FALSE, TRUE)
	Endif

	If equipBra
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousBra, tags = "bra", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	If equipNPiercings
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousPiercingsNipple, tags = "piercing,nipple", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	If equipCollar
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousCollar, tags = "collar", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	If equipACuffs
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousArmCuffs, tags = "cuffs,arms", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	If equipLCuffs
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousLegCuffs, tags = "cuffs,legs", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	If equipBlindfold
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousBlindfold, tags = "blindfold", requireAll = false, tagsToSuppress = exclTags+blindfoldExclTags), TRUE, FALSE, TRUE)
	Endif

	If equipArmbinder
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousArmbinder, tags = "armbinder", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	If equipYoke
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousYoke, tags = "yoke", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	If equipBoots
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousBoots, tags = "boots", requireAll = false, tagsToSuppress = exclTags+bootsExclTags), TRUE, FALSE, TRUE)
	Endif

	If equipGloves
		Libs.ManipulateGenericDevice(PlayerRef, Libs.GetDeviceByTags(Libs.zad_DeviousGloves, tags = "gloves", requireAll = false, tagsToSuppress = exclTags), TRUE, FALSE, TRUE)
	Endif

	Trace("Devious Captures: equipping devices finished")

EndFunction
